﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Text
Imports System.Linq
Imports System.Collections.Generic
Imports System
Imports System.Runtime.CompilerServices

  Public Class Player
        Implements INotifyPropertyChanged

        Private Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

        Private m_name As String
        Private m_number As Integer
        Private m_position As Position
        Private m_country As String

        Public Property Name() As String
            Get
                Return Me.m_name
            End Get
            Set
                If Value <> Me.m_name Then
                    Me.m_name = Value
                    Me.OnPropertyChanged("Name")
                End If
            End Set
        End Property

        Public Property Number() As Integer
            Get
                Return Me.m_number
            End Get
            Set
                If Value <> Me.m_number Then
                    Me.m_number = Value
                    Me.OnPropertyChanged("Number")
                End If
            End Set
        End Property

        Public Property Position() As Position
            Get
                Return Me.m_position
            End Get
            Set
                If Value <> Me.m_position Then
                    Me.m_position = Value
                    Me.OnPropertyChanged("Position")
                End If
            End Set
        End Property

        Public Property Country() As String
            Get
                Return Me.m_country
            End Get
            Set
                If Value <> Me.m_country Then
                    Me.m_country = Value
                    Me.OnPropertyChanged("Country")
                End If
            End Set
        End Property


        Public Sub New()
        End Sub

        Public Sub New(name As String, number As Integer, position As Position, country As String)
            Me.m_name = name
            Me.m_number = number
            Me.m_position = position
            Me.m_country = country
        End Sub

        Private Sub OnPropertyChanged(Optional ByVal propertyName As String = Nothing)
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
        End Sub

        Public Shared Function GetPlayers() As ObservableCollection(Of Player)
            Return New ObservableCollection(Of Player)(Club.GetClubs().SelectMany(Function(c) c.Players))
        End Function

        Public Overrides Function ToString() As String
            Return Me.Name
        End Function
    End Class
